/*
Created by Hakuryu188
www.hakuryu188-dev.blogspot.com
SMB 0.11
Licence: CC
*/

#include <pspkernel.h>
#include <pspctrl.h>
#include <pspdebug.h>
#include <psppower.h>
#include <pspdisplay.h>


PSP_MODULE_INFO("PRX", 0x1000, 1, 1);
PSP_MAIN_THREAD_ATTR(0);

#define printf pspDebugScreenPrintf

void BASIC_CPUClock(char variables);
void BASIC_CTRL();
void BASIC_Sleep(int secondes);
void BASIC_TurnOffScreen();
void menu();

unsigned char statut = 0;
unsigned char value = 0;
unsigned char HOLD;
unsigned char HOLD2;
unsigned char LEFT;
unsigned char RIGHT;
int temps;
unsigned char turnoffscreenvalue = 1;
unsigned char holdvalue = 1;
unsigned char turnoffscreenvalue2;
unsigned char holdvalue2;
unsigned char select;
unsigned char config;
unsigned char x;
unsigned char y;
int CPU;
unsigned char locked;
unsigned char stat;

int main_thread(SceSize args, void *argp)
{
	pspDebugScreenInit();

	statut = 1;
	temps = 0;

	BASIC_Sleep(6);

	while(1)
	{

		BASIC_CTRL();

		scePowerTick(PSP_POWER_TICK_DISPLAY);

		menu();



		if (statut == 1){

			if (HOLD == 1 && holdvalue == 1){
				value = 100;
				statut = 2;
				locked = 1;
			}else {
				locked = 0;
				if (LEFT == 1) {
					sceDisplaySetBrightness(25, 0);
				}
				if (RIGHT == 1) {
					sceDisplaySetBrightness(99, 0);
				}
			}

		}else if (statut == 2) {

			sceDisplaySetBrightness(value, 0);

			if (value > 0){
				value--;
			}else {
			    BASIC_CPUClock(3);
				sceSysconCtrlLED(1, 0);
				sceSysconCtrlLED(2, 0);
				sceSysconCtrlLED(0, 0);
				statut = 3;
			}

		}else if (statut == 3) {

			if (HOLD == 0){
				sceSysconCtrlLED(1, 1);
				sceSysconCtrlLED(2, 1);
				sceSysconCtrlLED(0, 1);
				BASIC_CPUClock(1);
				value = 0;
				statut = 4;
			}

		}else if (statut == 4) {

			sceDisplaySetBrightness(value, 0);

			if (value < 100){
				value++;
			}else {
				statut = 5;
			}

		}else if (statut == 5) {

			sceDisplaySetBrightness(60, 1);

			statut = 1;

		}



   sceKernelDelayThread(3000);

	}

   return 0;
}

int module_start(SceSize args, void *argp)
{
int thid = sceKernelCreateThread("PRX", main_thread, 0x30, 0x1000, 0, NULL);
if(thid >= 0) sceKernelStartThread(thid, args, argp);

return 0;
}

void BASIC_CPUClock(char variables)
{
	if (variables == 1){
		scePowerSetClockFrequency(333, 333, 166);
	}else if (variables == 2){
		scePowerSetClockFrequency(222, 222, 111);
	}else if (variables == 3){
		scePowerSetClockFrequency(111, 111, 111/2);
	}else {
		scePowerSetClockFrequency(222, 222, 111);
	}
}

void menu()
{
	if (config == 1){

		pspDebugScreenSetXY(11,4);
		pspDebugScreenPrintf("+++++SMB 0.11 By Hakuryu188+++++");

		pspDebugScreenSetXY(13,5);
		pspDebugScreenPrintf("Automatic turn off screen: %d", turnoffscreenvalue2);

		pspDebugScreenSetXY(13,6);
		pspDebugScreenPrintf("Hold turn off screen: %d", holdvalue2);

		pspDebugScreenSetXY(13,7);
		pspDebugScreenPrintf("Press start to exit");

		pspDebugScreenSetXY(11,8);
		pspDebugScreenPrintf("++++++++++++++++++++++++++++++++");

		if (select == 1){
			x = 10;
			y = 5;
		}else if (select == 2) {
			x = 10;
			y = 6;
		}

		pspDebugScreenSetXY(x,y);
		pspDebugScreenPrintf("->");


	}
}

void BASIC_CTRL()
{
	SceCtrlData pad;
	sceCtrlPeekBufferPositive(&pad, 1);
	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);


	if (pad.Buttons & PSP_CTRL_HOLD){
		HOLD = 1;
	}else {
		HOLD = 0;
	}

	if (pad.Buttons & PSP_CTRL_SELECT && pad.Ly < (127.5 - 50)){
		HOLD2 = 1;
	}else {
		HOLD2 = 0;
	}

	//////////////////////////////////////////////

	if (pad.Ly < (127.5 - 50)){
		if (pad.Buttons & PSP_CTRL_RTRIGGER && LEFT == 0){
			RIGHT = 1;
		}else {
			RIGHT = 0;
		}
		if (pad.Buttons & PSP_CTRL_LTRIGGER && RIGHT == 0){
			LEFT = 1;
		}else {
			LEFT = 0;
		}
	}

	//////////////////////////////////////////////

	/*
	pspDebugScreenSetXY(1,1);
	pspDebugScreenPrintf("CPU %d",CPU);
	pspDebugScreenSetXY(1,2);
	pspDebugScreenPrintf("CPU speed: %d", scePowerGetCpuClockFrequency());
	*/

	if (temps < 5000){
		CPU = scePowerGetCpuClockFrequency();
	}

	if (turnoffscreenvalue == 1 && locked == 0){
		if (pad.Buttons & PSP_CTRL_START || pad.Buttons & PSP_CTRL_SELECT || pad.Buttons & PSP_CTRL_SCREEN || pad.Buttons & PSP_CTRL_NOTE || pad.Buttons & PSP_CTRL_RTRIGGER || pad.Buttons & PSP_CTRL_LTRIGGER || pad.Buttons & PSP_CTRL_CROSS || pad.Buttons & PSP_CTRL_CIRCLE || pad.Buttons & PSP_CTRL_TRIANGLE || pad.Buttons & PSP_CTRL_SQUARE || pad.Buttons & PSP_CTRL_UP || pad.Buttons & PSP_CTRL_DOWN || pad.Buttons & PSP_CTRL_LEFT || pad.Buttons & PSP_CTRL_RIGHT){
			if (temps > 5000) scePowerSetClockFrequency(CPU, CPU, CPU/2);
			if (stat == 1){
				temps = 0;
				sceDisplaySetBrightness(40, 0);
				stat = 0;
			}
		}else {
			if (temps < 5010) temps++;
		}

		if (temps > 1000){
			sceDisplaySetBrightness(25, 0);
			stat = 1;
		}

		if (temps > 5000){
			sceDisplaySetBrightness(0, 0);
			BASIC_CPUClock(3);
		}
	}

	//////////////////////////////////////////////

	if (pad.Buttons & PSP_CTRL_RTRIGGER && pad.Buttons & PSP_CTRL_START){
		select = 1;
		turnoffscreenvalue2 = turnoffscreenvalue;
		holdvalue2 = holdvalue;
		config = 1;
	}

	if (config == 1){

		sceCtrlReadBufferPositive (&pad, 1);

		if (pad.Buttons & PSP_CTRL_START){
			turnoffscreenvalue = turnoffscreenvalue2;
			holdvalue = holdvalue2;
			config = 0;
		}

		if (pad.Buttons & PSP_CTRL_UP && select == 2) select = 1;
		if (pad.Buttons & PSP_CTRL_DOWN && select == 1) select = 2;

		if (select == 1){
			if (pad.Buttons & PSP_CTRL_LEFT){
				if (turnoffscreenvalue2 == 1){
					turnoffscreenvalue2 = 0;
				}
			}
			if (pad.Buttons & PSP_CTRL_RIGHT){
				if (turnoffscreenvalue2 == 0){
					turnoffscreenvalue2 = 1;
				}
			}
		}else if (select == 2){
			if (pad.Buttons & PSP_CTRL_LEFT){
				if (holdvalue2 == 1){
					holdvalue2 = 0;
				}
			}
			if (pad.Buttons & PSP_CTRL_RIGHT){
				if (holdvalue2 == 0){
					holdvalue2 = 1;
				}
			}
		}


	}

	//////////////////////////////////////////////
}

void BASIC_Sleep(int secondes)
{
	sceKernelDelayThread(1000000*secondes);
}
